##################################################
# VerChor Copyright (C) 2013-2014 University of Grenoble Alpes

# This program is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either # version 2 of the License, or (at your option) any later 
# version.

# This program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more 
# details.

# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the Free 
# Software Foundation, Inc., 51 Franklin Street, Fifth Floor, # Boston, MA 02110-1301 USA.

# http://www.gnu.org/copyleft/gpl.html

# Contributors:  
# Gwen Salaün
# Lina Ye 

##################################################



if __name__ == '__main__':

	import re
	# import numpy as np
        import sys

        infile = sys.argv[1]
        basefile= sys.argv[2]
        print infile
        print basefile 

	string=open(infile).read()
	string=string[4:]
	#string="begin "+string
	new_str=re.sub('[^a-zA-Z0-9\n\.\ \_]', '', string)
	# new_str=re.sub('\_', ' ', new_str)
	open(basefile+'_try.aut','w').write(new_str)

##################################################
     #   data=open(basefile+"_try.aut").read()
     #   ins=open(basefile+"_try.aut", "r")
     #   lines=[]
     #   for line in ins
     #           lines.append(line)
     #   ins.close
     #   for j in range(0, len(lines))
     #           data[j]=lines[j].split(" ")
########################################################
        
######################################################
        lines=tuple(open(basefile+"_try.aut", "r"))
        data=[[0 for x in xrange(3)] for x in xrange(len(lines))]
        for j in range(0, len(lines)):
              data[j]=[s.strip() for s in lines[j].split(' ')]
##################################################

      #	data=np.genfromtxt(basefile+"_try.aut", delimiter=" ", dtype=None)
      
                                             
  
	setPeers=list()
	setStates=list()
	setStates.append(data[0][0])
	for i in range(1,len(data)):
		if data[i][1]!='exit':
			tem=data[i][1].split('_')
			tem.remove(tem[2])
			for t in tem:
				if t not in setPeers:
					setPeers.append(t)
		if data[i][0] not in setStates:
			setStates.append(data[i][0])
 		if data[i][2] not in setStates:
			setStates.append(data[i][2])
	f=open('cpExa.py', 'w')
        f.write("from controllerGeneration import *\n")
	f.write("class ExternalExamples:\n\n")
	f.write("	# Builds CP instance\n")
	f.write("	def cp_example(self):\n\n")
	f.write("		# states\n")
	for s in setStates:
		f.write("		st"+str(s)+"=State(\""+str(s)+"\")\n")
        f.write("		#cp init\n")
	f.write("		cp_example=CP(\"cp_example\", st"+str(setStates[0])+")\n")
	f.write("		# add states\n")
        for s in setStates:
		f.write("		cp_example.addState(st"+str(s)+")\n")
	f.write("		# Peers\n")
	for p in setPeers:
		f.write("		"+p+"=Peer(\""+p+"\")\n")  
	f.write("		# add transitions\n") 
	for i in range(1, len(data)):
		if data[i][1]!='exit': 
			tem1=data[i][1].split('_')
			f.write("		cp_example.addTransition(Transition(st"+str(data[i][0])+",Label("+tem1[0]+","+tem1[1]+",\""+tem1[2]+"\"),st"+str(data[i][2])+"))\n")
        f.write("		\n\n\n")
	f.write("		return cp_example\n") 
    
